import greenfoot.*;
import java.util.List;

public class Space extends World
{
    public Space()
    {
        super(1000, 600, 1);
        // darken background
        getBackground().setColor(new Color(15, 15, 15));
        getBackground().fill();
        // add sun
        Orb.setColor(255, 255, 0);
        Orb.radius = 200;
        addObject(new Sun(), 500, 300);
        // add Mercury
        Orb.setColor(100, 20, 20);
        Orb.radius = 10;
        Planet mercury = new Planet(116, 88);
        addObject(mercury, 0, 0);
        mercury.setOrbitalPosition();
        // add Venus
        Orb.setColor(50, 50, 50);
        Orb.radius = 24;
        Planet venus = new Planet(216, 224);
        addObject(venus, 0, 0);
        venus.setOrbitalPosition();
        // add Earth
        Orb.setColor(50, 100, 100);
        Orb.radius = 26;
        Planet earth = new Planet(299, 365);
        addObject(earth, 0, 0);
        earth.setOrbitalPosition();
        // add Mars
        Orb.setColor(100, 50, 50);
        Orb.radius = 14;
        Planet mars = new Planet(456, 687);
        addObject(mars, 0, 0);
        mars.setOrbitalPosition();
    }
    
    // paint the planets in the order of furthest to nearest
    // (it is enough to sort by the objects y-coordinates since
    //  closer objects are given higher y-coordinate values)
    public void act()
    {
        List<Actor> actors = getObjects(null); // get list of all actors
        boolean changed = true;
        do
        {
            changed = false;
            for (int i=1; i<actors.size(); i++)
            { // starting with second element, go through list of actors
                if (((Actor)actors.get(i)).getY() < ((Actor)actors.get(i-1)).getY())
                { // if not sorted correctly with element before it, swap elements
                    Actor hold = actors.get(i);
                    actors.set(i,actors.get(i-1));
                    actors.set(i-1, hold);
                    changed = true;
                }
            }
        } while (changed); // continue until sorted
        for (Actor actor : actors)
        { // with each actor in list
            int x = actor.getX(); // save x of actor
            int y = actor.getY(); // save y of actor
            removeObject(actor); // remove actor from world
            addObject(actor, x, y); // re-add actor to same location in world
        }
    }
}